using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Core.Networks;
using System;
using System.Threading;

namespace HeuristicLab.Networks.Programmable {
  [Item("MyProgrammableNetwork", "A programmable network.")]
  public class MyProgrammableNetwork : ProgrammableNetwork.CompiledProgrammableNetwork {
    protected MyProgrammableNetwork(MyProgrammableNetwork original, Cloner cloner) : base(original, cloner) { }
    public MyProgrammableNetwork(ProgrammableNetwork context) : base(context) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new MyProgrammableNetwork(this, cloner);
    }

    protected override void MessagePort_MessageReceived(object sender, EventArgs<IMessage, CancellationToken> e) {
      // implement processing of messages here
    }
  }
}
